function c = cfloating( a, rValue, lValue )
if nargin == 0
    c.m_pMiller = [];
    c.m_RValue = 0.0;
    c.m_LValue = [];
    c = class( c, 'cfloating' );
    return
end
if nargin == 1
   if isa( a, 'cfloating' )
       c = a;
       return
   end
   if isnumeric( a )
       assert( isreal( a ), 'Array is not REAL!' );
       assert( all( isfinite( a(:) ) ), 'Array has inf or NaN element!' );
       c = struct( 'm_pMiller', {[]}, 'm_RValue', num2cell( a ), 'm_LValue', {[]} );
       c = reshape( c, size( a ) );
       c = class( c, 'cfloating' );
       return
   end
end
if nargin == 3
    if isa( a, 'miller_ptr' )
        if any( lValue(:) == 0.0 )
           error('Left value is 0!');
        end
        c = struct( 'm_pMiller', {a}, 'm_RValue', num2cell( rValue ), 'm_LValue', num2cell( lValue ) );
        c = reshape( c, size( rValue ) );
        c = class( c, 'cfloating' );
%        c
%        c.m_pMiller = a;
%        c.m_RValue = rValue;
%        c.m_LValue = lValue;
%        c = class( c, 'cfloating' );
        return
    end
end
error('Invalid constructor call for class cfloating');
     