function display( c )
disp( ' ' );
s = size( c );
ls = length( s );
axb='';
if ls > 0
    axb = [num2str( s(1) ), ' '];
end
for i = 2 : ls
    axb = [ axb, 'x ', num2str( s( i ) ), ' ' ];
end
disp( [inputname(1), ' is a ' axb, class( c ), ' array' ])
n = numel( c );
CELL = cell( s );
for i = 1 : n
    element = c(i);
    state = 'e'; 
    lval= '|lv    ';
    wkl ='|wkl   0';
    if isempty( element.m_LValue )
        if isempty( element.m_pMiller )
            state = 'u';
        end
    else
        if ~isempty( element.m_pMiller ) && element.m_LValue ~= 0
            state = 'n';
            lval = ['|lv ', sprintf( '%3d', element.m_LValue ) ];
            DM = miller('');
            mptr = FillBegin( DM );
            if isvalid( mptr )
                try
                    FillWith( mptr, miller_ptr( element.m_pMiller ) );
                    element.m_pMiller = mptr;
                    output( element );
                catch
                end
                if FillEnd( mptr )
                    set( DM, 'error_measure', 'wkl' );
                    try
                        rho = ComputeRho( DM );
                    catch
                        rho = 0.0;
                    end
                    wkl = ['|wkl ', num2str( rho, '%11.4e' ) ];
                end
                destroy( DM );
            end
        end
    end
    rval = ['|rv ', num2str( element.m_RValue, '%11.4e' ) ];
    CELL{i} = [ state, lval, rval, wkl ];
end
disp( CELL );
