function c = mtimes( a, b )
try
    [a, b, m_pMiller, aRValue, bRValue] = verifyargs( a, b );
catch
    error( 'Invalid arguments for ''*''!' );
end
if isempty( m_pMiller )
    RValue = aRValue * bRValue;
    try
        c = cfloating( RValue );
    catch
        error( 'Error creating ''*'' node!' );
    end
    return;
end
ptr = get_ptr( m_pMiller );
if isscalar( a )
    RValue = aRValue * bRValue;
    s = size( RValue );
    n = numel( RValue );
    LValue = zeros( s );
    for i = 1 : n
        LValue(i) = roundoff( ptr, 4, a.m_LValue, 3, b(i).m_LValue, aRValue, bRValue(i), RValue(i) );
    end
elseif isscalar( b )
    RValue = aRValue * bRValue;
    s = size( RValue );
    n = numel( RValue );
    LValue = zeros( s );
    for i = 1 : n
        LValue(i) = roundoff( ptr, 4, a(i).m_LValue, 3, b.m_LValue, aRValue(i), bRValue, RValue(i) );
    end
else
    [n,k] = size( aRValue );
    [l,m] = size( bRValue );
    assert( k == l, 'Inner matrix dimensions must agrree!' );
    RValue = zeros( n, m );
    LValue = RValue;        
    for i = 1 : n
        for j = 1 : m
            rSum = 0.0;
            lSum = roundoff( ptr, 1, 0.0 );
            assert( lSum ~= 0.0, 'Error creating ''*'' node!' );
            for k = 1 : l
                rProd = aRValue(i,k) * bRValue(k,j);
                lProd = roundoff( ptr, 4, a(i,k).m_LValue, 3, b(k,j).m_LValue, aRValue(i,k), bRValue(k,j), rProd );
                assert( lProd ~= 0.0, 'Error creating ''*'' node!' );
                rNext = rSum + rProd;
                lSum = roundoff( ptr, 4, lSum, 1, lProd, rSum, rProd, rNext );
                assert( lSum ~= 0.0, 'Error creating ''*'' node!' );
                rSum = rNext;
            end
            RValue(i,j) = rSum;
            LValue(i,j) = lSum;
        end
    end
end
try
    c = cfloating( m_pMiller, RValue, LValue );
catch
    error( 'Error creating ''*'' node!' );
end
end
