function [a, b, m_pMiller, aRValue, bRValue] = verifyargs( a, b )
a = cfloating( a );
b = cfloating( b );
aRValue = getRValue( a );
bRValue = getRValue( b );
m_pMiller = getptr( a, b );
if isempty( m_pMiller )
    return;
end
a = verif( a, m_pMiller );
b = verif( b, m_pMiller );
end

function RValue = getRValue( c )
c = slice( c );
s = size( c );
Cell = cell( s );
[Cell{:}] = deal( c.m_RValue );
RValue = reshape( cell2mat( Cell ), s );
end

function c = verif( c, m_pMiller )
sc = slice( c );
if numel( [sc.m_pMiller] ) < numel( sc )
    [Cell{ 1 : numel( sc ) }] = deal( sc.m_pMiller );
    ind = find( cellfun( @isempty, Cell ) );
    c( ind ) = constant( m_pMiller, [sc( ind ).m_RValue] );
end
end

function m_pMiller = getptr( a, b )
a = slice( a );
b = slice( b );
tmp = [a.m_pMiller];
if ~isempty( tmp )
   m_pMiller = tmp( 1 );
else
    tmp = [b.m_pMiller];
    if ~isempty( tmp )
        m_pMiller = tmp( 1 );
    else
        m_pMiller = [];
    end
end
end