function display( m )
if ~get( m, 'is_compare' )
    s = ['analysing algorithm ', get( m, 'algorithm' ) ];
else
    s = ['comparing algorithm ', get( m, 'algorithm' ), ' with ', get( m, 'ref_alg' )];
end
disp(['Object of type miller for ', s]);
disp(['The method for evaluating derivatives is: ', get( m, 'diff_method' ) ]);
rho = get(m, 'rho' );
if rho > 0
    disp( sprintf( 'The error measuring number is: %s = %g', get( m, 'error_measure' ), get( m, 'rho' ) ) );
else
    disp( sprintf( 'The error measuring number is: %s', get( m, 'error_measure' ) ) );
end
disp( sprintf( 'The stopping value is: %g',  get( m, 'stop_crit' ) ) );
calls = get( m, 'num_of_calls' );
disp( sprintf( 'During last search %d calls were made', calls ) );
disp( sprintf( 'The number of inputs: %d', get( m, 'num_of_inputs' ) ) );
disp( sprintf( 'The number of operations: %d %d', get( m, 'num_of_operations' ) ) );
disp( sprintf( 'The number of constants: %d %d', get( m, 'num_of_constants' ) ) );
disp( sprintf( 'The number of outputs: %d', get( m, 'num_of_outputs' ) ) );
disp( sprintf( 'The number of constraints: %d', get( m, 'num_of_constraints' ) ) );
disp( sprintf( 'The penalty is: %g', get( m, 'penalty' ) ) );
if roundoff( m.ptr, 1002, 3 ) > 0
    disp( sprintf( 'The size of Ukkonen matrix: %d', get( m, 'size_of_w' ) ) );
end
a = get( m, 'memory' );
disp( sprintf( 'Memory allocated: %d', a(1) ) );
disp( sprintf( 'Memory used: %d\n', a(2) ) );
a = get( m, 'exceptions' );
if any( a )
disp( sprintf( 'Reporting the number of errors:' ) );
end
if a(1) > 0
    disp( sprintf( 'Division by zero: %d', a(1) ) );
end
if a(2) > 0
    disp( sprintf( 'Square root of negative number: %d', a(2) ) );
end
if a(3) > 0
    disp( sprintf( 'GETER failure: %d', a(3) ) );
end
if a(4) > 0
    disp( sprintf( 'OMEGA failure: %d', a(4) ) );
end
if a(5) > 0
    disp( sprintf( 'DIAGON failure: %d', a(5) ) );
end
if a(6) > 0
    disp( sprintf( 'CONDIT failure: %d', a(6) ) );
end
if a(7) > 0
    disp( sprintf( 'CHOLESKY failure: %d', a(7) ) );
end
if a(8) > 0
    disp( sprintf( 'GENEIG failure: %d', a(8) ) );
end
if a(9) > 0
    disp( sprintf( 'TRIDIAGON failure: %d', a(9) ) );
end
if a(10) > 0
    disp( sprintf( 'EIGEN failure: %d', a(10) ) );
end
if a(11) > 0
    disp( sprintf( 'USER error: %d', a(11) ) );
end
    
if get( m, 'is_stop' )
    disp( sprintf( '\nStop flag set. \nPlease call reset or resetcounter before continue.\n' ) );
elseif strcmp( get(m, 'mode' ), 'search' ) && calls > 0 
    disp( sprintf( '\nReady to perform optimization!\n' ) );
end

  