function x = GaussScalar( A, b )
[n,m] = size(A);
assert( n == m, 'A is not a square matrix!' );
m = numel( b );
assert( n == m, 'b must have as many elements as the columns of A!' );
x = zeros( n, 1 );
x = feval( class(A), x );
for k = 1 : n - 1
    for i = k + 1 : n
        amult = A(i,k) / A(k,k);
        for j = k + 1 : n
            A(i,j) = A(i,j) - amult * A(k,j);
        end
        b(i) = b(i) - amult * b(k);
    end
end
for i = n : -1 : 1
    sum = 0.0;
    for j = i + 1 : n
        sum = sum + A(i,j) * x(j);
    end
    x(i) = ( b(i) - sum ) / A(i,i);
end
