function [x, C] = gppConstr( A, b )
[n,m] = size(A);
assert( n == m, 'A is not a square matrix!' );
m = numel( b );
assert( n == m, 'b must have as many elements as the columns of A!' );
x = zeros( n, 1 );
x = feval( class(A), x );
C = zeros( n * ( n - 1 ) / 2, 1 );
j = 0;
for k = 1 : n - 1
    for i = k + 1 : n
        amult = A(i,k) / A(k,k);
        j = j + 1;
        C(j) = ( 1.0 - abs( value( amult ) ) ) * 100.0 ;
        A(i,k+1:n) = A(i,k+1:n) - amult * A(k,k+1:n);
        b(i) = b(i) - amult * b(k);
    end
end
for i = n : -1 : 1
    x(i) = ( b(i) - A(i,i+1:n) * x(i+1:n) ) / A(i,i);
end
