function C=Strassen(A,B)
% O(n^3) Strassen algorithm for computing C=A*B
% A and B are assumed to be square of order 2^k
[m,k] = size( A );
[l,n] = size( B );
assert( m == k && k == l && l == n, 'A and B must be squere matrices of the same order!' );
k = uint32( m );
assert( bitand( k, k - 1 ) == 0, 'The order of A and B must be the form of 2^k' );
%
if n == 1
    C = A * B;
    return;
end

d = n / 2;
d1 = d + 1;
A11=A(1:d,1:d);
A12=A(1:d,d1:n);
A21=A(d1:n,1:d);
A22=A(d1:n,d1:n);
%
B11=B(1:d,1:d);
B12=B(1:d,d1:n);
B21=B(d1:n,1:d);
B22=B(d1:n,d1:n);
%

[C11,C12,C21,C22]=Str2x2(A11,A12,A21,A22,B11,B12,B21,B22);

C(1:d,1:d)=C11;
C(1:d,d1:n)=C12;
C(d1:n,1:d)=C21;
C(d1:n,d1:n)=C22;
