function C=Winograd(A,B)
% O(n^3) Winograd algorithm for computing C=A*B
% Inner dimensions assumed to be even
[m,k] = size( A );
[l,n] = size( B );
assert( k == l, 'Inner matrix dimensions must agrree!' );
assert( mod(k, 2) == 0, 'Inner matrix dimensions must be even!' );
%
rowFactor = feval( class(A), zeros( m, 1 ) );
columnFactor = feval( class(A), zeros( 1, n ) );
for i=1:m
    rowFactor(i) = A(i,1:2:k) * A(i,2:2:k)';
end
for j=1:n
    columnFactor(j) = B(1:2:k,j)' * B(2:2:k,j);
end

C = -repmat( rowFactor, 1, n );
%
C = C - repmat( columnFactor, m, 1 );
%
for i=1:m
    for j=1:n
        C(i,j)=C(i,j)+(A(i,1:2:k)+B(2:2:k,j)')*(A(i,2:2:k)'+B(1:2:k,j));
    end
end
