function C=WinogradS(A,B)
% O(n^3) Winograd algorithm for computing C=A*B
% Inner dimensions assumed to be even
[m,k] = size( A );
[l,n] = size( B );
assert( k == l, 'Inner matrix dimensions must agrree!' );
assert( mod(k, 2) == 0, 'Inner matrix dimensions must be even!' );
d=k/2;
%
for i=1:m
    rowFactor(i)=A(i,1)*A(i,2);
    for j=2:d
        rowFactor(i)=rowFactor(i)+A(i,2*j-1)*A(i,2*j);
    end
end
%
for i=1:n
    columnFactor(i)=B(1,i)*B(2,i);
    for j=2:d
        columnFactor(i)=columnFactor(i)+B(2*j-1,i)*B(2*j,i);
    end
end
%
for i=1:m
    for j=1:n
        C(i,j)=-rowFactor(i)-columnFactor(j);
        for l=1:d
            C(i,j)=C(i,j)+(A(i,2*l-1)+B(2*l,j))*(A(i,2*l)+B(2*l-1,j));
        end
    end
end
