CCCCC*$pragma aux CKIIR "!" parm (value)
CCCCC*$pragma aux FNCTN "!"
      
 
      SUBROUTINE KIIR( CH, SOR )
C      INTERFACE
C        SUBROUTINE CKIIR (I)
C        !DEC$ ATTRIBUTES C, ALIAS:'_cKiir' :: CKIIR 
C          CHARACTER I
C        END SUBROUTINE CKIIR
C      END INTERFACE

        CHARACTER*120 CH(6)
        INTEGER SOR, I
        DO 50 I=1,SOR
            CALL CKIIR( CH(I)(1:110)//CHAR(0) )
  50    CONTINUE      
      END 
         

         
      
      
      SUBROUTINE ROSEN_FOR( D, NVARY, P, DEL, 
     *                       DOLD, DSAVE, BIGDEL, GLOBALS)
C A VARIANT OF ROSENBROCK'S METHOD, PP. 21-22 OF 'NUMERICAL
C METHODS FOR UNCONSTRAINED OPTIMIZATION', W. MURRAY,ED.
C ACADEMIC PRESS, 1972.
      INTEGER DATSIZE
      CHARACTER*120 CHFILE(6)
      INTEGER NITER(2)
      INTEGER NVARY, NFLAG, NOUT, IERR, NROT
      INTEGER NTIMES, ITER
      INTEGER I, J, K
      INTEGER MOVE, NM1, JBACK
      DOUBLE PRECISION P(NVARY,*), DEL(*), EPS(2)
      DOUBLE PRECISION DOLD(*)
      DOUBLE PRECISION D(*), DSAVE(*), BIGDEL(*)
      DOUBLE PRECISION B, FNCTN, ONE, RHO, BETA, DELI 
      DOUBLE PRECISION SIZE, ZERO, ALPHA, DELTA
      DOUBLE PRECISION DNORM, CHANGE, RHOSAV, THEMIN, DABSBD
      DOUBLE PRECISION DABS
   
      INTEGER GLOBALS
      SAVE
C P'S COLUMNS ARE THE SEARCH DIRECTIONS.
C DOLD STORES THE POSITION OF D AFTER THE MOST RECENT ROTATION.
C DSAVE IS THE SAVE AREA FOR D WHEN A STEP IS TRIED.
C DEL(I) IS THE STEP LENGTH IN THE I-TH DIRECTION.
C BIGDEL(I) IS THE ALGEBRAIC SUM OF ALL SUCCESSFUL STEPS IN THE I-TH
C   DIRECTION.
C
C THESE VALUES DEPEND UPON THE PRECISION AND THE INSTALLATION.
C FOR SINGLE PRECISION OMIT 'D0' FROM THE FOLLOWING CONSTANTS.
C ALSO CHANGE 'DABS'.
     
      DATSIZE=NVARY
C
C INITIALIZE THE SEARCH DIRECTIONS TO THE COORDINATE AXES.
      ALPHA=3.0D0
      BETA=-0.5D0
      CHANGE=20.0D0
      EPS(1)=0.03D0
      EPS(2)=0.001D0
      ONE=1.0D0
      ZERO=0.0D0
      NITER(1)=5
      NITER(2)=9
      NFLAG=1
      NOUT=6
      
      DO 20 I=1,NVARY
        DO 10 J=1,NVARY
          P(I,J) = ZERO
   10   CONTINUE
        P(I,I) = ONE
   20 CONTINUE
      RHO = FNCTN(D, IERR, GLOBALS )
      IF (IERR.EQ.1) GO TO 150
C
C NROT-1 IS THE CURRENT NUMBER OF ROTATIONS OF THE SEARCH DIRECTIONS.
C THE SEARCH PROCEDURE IS REFINED IF RHO .GT. CHANGE.
      DO 140 NROT=1,10
        IF (RHO.GT.CHANGE) NFLAG = 2
        DNORM = ZERO
        DO 30 I=1,NVARY
          SIZE = DABS(D(I))
          IF (SIZE.GT.DNORM) DNORM = SIZE
          DOLD(I) = D(I)
   30   CONTINUE
        DELTA = EPS(NFLAG)*DNORM
        DO 40 I=1,NVARY
          BIGDEL(I) = ZERO
          DEL(I) = DELTA
   40   CONTINUE
        NTIMES = NITER(NFLAG)
        DO 90 ITER=1,NTIMES
          DO 80 I=1,NVARY
            DELI = DEL(I)
            RHOSAV = RHO
            DO 50 K=1,NVARY
              DSAVE(K) = D(K)
              D(K) = D(K) + DELI*P(K,I)
   50       CONTINUE
            RHO = FNCTN(D, IERR, GLOBALS)
            IF (IERR.EQ.1) GO TO 150
            IF (RHO.GT.RHOSAV) GO TO 70
C
C SEARCH WAS UNSUCCESSFUL.
            DEL(I) = BETA*DELI
            DO 60 K=1,NVARY
              D(K) = DSAVE(K)
   60       CONTINUE
            RHO = RHOSAV
            GO TO 80
C
C SEARCH WAS SUCCESSFUL.
   70       BIGDEL(I) = BIGDEL(I) + DELI
            DEL(I) = ALPHA*DELI
   80     CONTINUE
   90   CONTINUE
        IF (NROT.EQ.10) GO TO 150
        IF (NVARY.EQ.1) GO TO 140
C
C ROTATE THE SEARCH DIRECTIONS.
C GUARANTEE SOME CHANGE IN EACH DIRECTION.  IF INSUFFICIENT PROGRESS
C IS MADE, THEN TERMINATE THE SEARCH.
        THEMIN = EPS(NFLAG)*DELTA
        MOVE = 0
        DO 100 I=1,NVARY
          DABSBD = DABS(BIGDEL(I))
          IF (DABSBD.GT.THEMIN) MOVE = 1
          IF (DABSBD.LE.THEMIN) BIGDEL(I) = THEMIN
  100   CONTINUE
        IF (MOVE.EQ.0) GO TO 160
C
C SET THE J-TH COLUMN OF P TO THE SUM OF THE SUCCESSFUL STEPS IN THE
C OLD DIRECTIONS J, J-1,..., NVARY.  SINCE THE OLD DIRECTIONS ARE
C ORTHOGONAL AND SINCE THE BIGDELS ARE NONZERO, THE NEW COLUMNS ARE
C LINEARLY INDEPENDENT.
        B = BIGDEL(NVARY)
        DO 110 I=1,NVARY
          P(I,NVARY) = B*P(I,NVARY)
  110   CONTINUE
        NM1 = NVARY - 1
        DO 130 JBACK=1,NM1
          J = NVARY - JBACK
          B = BIGDEL(J)
          DO 120 I=1,NVARY
            P(I,J) = B*P(I,J) + P(I,J+1)
  120     CONTINUE
  130   CONTINUE
C
C ORTHOGONALIZE.  THE J-TH COLUMN OF P IS THE MOST PROFITABLE
C SEARCH DIRECTION ORTHOGONAL TO COLUMNS 1, 2,..., J-1.
        CALL GRAM(P, NVARY, DATSIZE, IERR)
        IF (IERR.EQ.1) GO TO 160
  140 CONTINUE
  150 RETURN
C
  160 CHFILE(1)='INSUFFICIENT PROGRESS. SEARCH ENDS.'
      CALL KIIR(CHFILE, 1)
      GO TO 150
99999 FORMAT (/10X, 35HINSUFFICIENT PROGRESS. SEARCH ENDS.)
      END

      SUBROUTINE GRAM(S, N, NDIM, IERR)
C APPLIES THE MODIFIED GRAM-SCHMIDT METHOD TO THE FIRST N
C COLUMNS OF S (AS N-VECTORS).
      CHARACTER*120 CHFILE(6)
      INTEGER NDIM
      INTEGER I, J, K, N, JP
      INTEGER IERR
      DOUBLE PRECISION S(NDIM,NDIM)
      DOUBLE PRECISION SUM, ZERO
      DOUBLE PRECISION DSQRT
      SAVE
C THESE VALUES DEPEND UPON THE PRECISION AND THE INSTALLATION.
C FOR SINGLE PRECISION OMIT 'D0' FROM THE FOLLOWING CONSTANTS.
C ALSO CHANGE 'DSQRT'.
      DATA ZERO /0.0D0/
C
      DO 60 J=1,N
        SUM = ZERO
        DO 10 I=1,N
          SUM = SUM + S(I,J)**2
   10   CONTINUE
        IF (SUM.EQ.ZERO) GO TO 80
        SUM = DSQRT(SUM)
        DO 20 I=1,N
          S(I,J) = S(I,J)/SUM
   20   CONTINUE
        IF (J.EQ.N) GO TO 60
        JP = J + 1
        DO 50 K=JP,N
          SUM = ZERO
          DO 30 I=1,N
            SUM = SUM + S(I,J)*S(I,K)
   30     CONTINUE
          DO 40 I=1,N
            S(I,K) = S(I,K) - SUM*S(I,J)
   40     CONTINUE
   50   CONTINUE
   60 CONTINUE
      IERR = 0
   70 RETURN
C
   80 CHFILE(1)='RANK DEFICIENCY IN SUBROUTINE GRAM. TERMINATE.'
      CALL KIIR(CHFILE, 1)
      IERR = 1
      GO TO 70
99999 FORMAT (47H RANK DEFICIENCY IN SUBROUTINE GRAM. TERMINATE.)
      END

      SUBROUTINE NMS_FOR(D, NVARY, FCUR, V, VBAR, PTR, GLOBALS)
      INTEGER DATSIZE, REFLECT, EXPAND, CONTRACT, SHRINK

      CHARACTER*120 CHFILE(6)
      INTEGER I, J   
      DOUBLE PRECISION D(*) 
      DOUBLE PRECISION FNCTN
      INTEGER NVARY, IERR
      DOUBLE PRECISION ALFA, BETA, GAMMA
      DOUBLE PRECISION STOPIT
      DOUBLE PRECISION FCUR( * )
      DOUBLE PRECISION V( NVARY, * ), VBAR(*)
      DOUBLE PRECISION SCALE, NORM, ALFA1, ALFA2
      DOUBLE PRECISION SIMPSIZE
      INTEGER PTR( * ), IMAX, ITEMP
      INTEGER APPLIED, TRGT, EMPTY
      INTEGER GLOBALS
      
      DATSIZE=NVARY
      REFLECT = DATSIZE + 2
      EXPAND = DATSIZE + 3
      CONTRACT = EXPAND
      SHRINK = 0
      
      ALFA=1.0D0
      BETA=5.0D-1
      GAMMA=2.0D0
      STOPIT=1.0D-5

      SCALE = 1.0
      DO 10 I=1,NVARY
        NORM=DABS(D(I))
        IF (NORM.GT.SCALE) SCALE=NORM
   10 CONTINUE
      ALFA1=SCALE/(NVARY*DSQRT(2.0D0))
      ALFA2=ALFA1
      ALFA1=ALFA1 * ( DSQRT( DBLE(NVARY) + 1.0D0 ) - 1.0D0 + NVARY )
      ALFA2=ALFA2 * ( DSQRT( DBLE(NVARY) + 1.0D0 ) - 1.0D0 )
      DO 20 I=1,NVARY
         V(I,1)=D(I)
         PTR(I)=I
   20 CONTINUE
      PTR( NVARY + 1 ) = NVARY + 1
C DEFINING THE INITIAL SIMPLEX      
      FCUR(1)=FNCTN(D, IERR, GLOBALS)
      IF (IERR.EQ.1) GO TO 500
      DO 50 J=2,NVARY+1
        DO 30 I=1,NVARY  
          IF (I.EQ.J-1) THEN
            V(I,J)=D(I)+ALFA1
          ELSE
            V(I,J)=D(I)+ALFA2
          END IF  
   30   CONTINUE
        FCUR(J)=FNCTN( V(1,J), IERR, GLOBALS )
        IF (IERR.EQ.1) GO TO 500
   50 CONTINUE
C SORTING THE VERTICES OF THE SIMPLEX
   55 DO 70 I=1,NVARY
        IMAX=I
        DO 60 J = I+1, NVARY+1 
          IF ( FCUR( PTR(J) ).GT.FCUR( PTR(IMAX) ) ) IMAX=J
   60   CONTINUE
        IF (IMAX.NE.I) THEN
          ITEMP=PTR(I)
          PTR(I)=PTR(IMAX)
          PTR(IMAX)=ITEMP
        END IF
   70 CONTINUE
C-------------------------------------------------
C MAIN LOOP
C-------------------------------------------------
C CHECK STOPPING CRITERION
  120 SIMPSIZE=0.0D0
      DO 140 J=2,NVARY+1
        NORM=0.0D0
        DO 130 I=1,NVARY
          NORM = NORM + DABS( V( I, PTR(J) ) - V( I, PTR(1) ) )
  130   CONTINUE
        IF (NORM.GT.SIMPSIZE) SIMPSIZE=NORM
  140 CONTINUE      
      NORM=0.0D0
      DO 150 I=1,NVARY
        NORM = NORM + DABS(V( I, PTR(1) ))
  150 CONTINUE
      IF (NORM.LT.1.0D0) NORM=1.0D0
      SIMPSIZE=SIMPSIZE/NORM
      IF (SIMPSIZE.LT.STOPIT) GO TO 510
      DO 170 I=1,NVARY
        VBAR(I)=0.0D0
        DO 160 J=1,NVARY
          VBAR(I)=VBAR(I)+V( I, PTR(J) )
  160   CONTINUE
        VBAR(I)=VBAR(I)/DBLE(NVARY)        
  170 CONTINUE         
C REFLECTION
      DO 180 I=1,NVARY
        V(I,REFLECT) = (1 + ALFA)*VBAR(I) 
     *                - ALFA * V( I, PTR(NVARY + 1) )        
  180 CONTINUE
      APPLIED = REFLECT             
      FCUR(REFLECT) = FNCTN(  V(1, REFLECT), IERR, GLOBALS )
      IF (IERR.EQ.1) GO TO 500
      IF ( FCUR(REFLECT).GT.FCUR( PTR(NVARY) ) ) THEN
        IF ( FCUR(REFLECT).GT.FCUR( PTR(1) ) ) THEN
C EXPAND
          DO 190 I=1,NVARY
            V(I, EXPAND) = GAMMA*V(I, REFLECT) + (1-GAMMA)*VBAR(I)
  190     CONTINUE
          FCUR(EXPAND) = FNCTN( V(1, EXPAND), IERR, GLOBALS )
          IF (IERR.EQ.1) GO TO 500
          IF ( FCUR(EXPAND).GT.FCUR(REFLECT) ) APPLIED=EXPAND
        END IF
      ELSE
C CONTRACT
        TRGT = PTR(NVARY + 1)
        IF ( FCUR(REFLECT).GT.FCUR(TRGT) ) TRGT=REFLECT
        DO 200 I=1,NVARY
          V(I,CONTRACT) = BETA*V(I, TRGT) + (1-BETA)*VBAR(I)
  200   CONTINUE
        FCUR(CONTRACT) = FNCTN ( V(1, CONTRACT), IERR, GLOBALS )
        IF (IERR.EQ.1) GO TO 500
        IF ( FCUR(CONTRACT).GT.FCUR(TRGT) ) THEN
          APPLIED=CONTRACT
        ELSE
C SHRINK
          DO 220 J=2, NVARY+1
            DO 210 I=1,NVARY
              V(I, PTR(J)) = ( V(I, PTR(1)) + V(I, PTR(J)) )/2.0D0
  210       CONTINUE
            FCUR( PTR(J) ) = FNCTN( V(1, PTR(J)), IERR, GLOBALS )
            IF (IERR.EQ.1) GO TO 500
  220     CONTINUE
          APPLIED=SHRINK
        END IF
      END IF
      IF (APPLIED.EQ.SHRINK) GO TO 55
      EMPTY = PTR( NVARY+1 )
      DO 230 I=1,NVARY
        V(I, EMPTY) = V(I, APPLIED)
        FCUR(EMPTY) = FCUR(APPLIED)        
  230 CONTINUE
      I=NVARY
  240 IF ( FCUR( APPLIED ).LE.FCUR( PTR(I) ) ) GO TO 250
      PTR(I+1) = PTR(I)
      IF ( I.EQ.1 ) GO TO 250
      I = I - 1
      GO TO 240
  250 PTR(I) = EMPTY
      GO TO 120
  500 RETURN
  510 CHFILE(1)='INSUFFICIENT PROGRESS. SEARCH ENDS.'
      CALL KIIR(CHFILE, 1)
      GO TO 500
99999 FORMAT (/10X, 35HINSUFFICIENT PROGRESS. SEARCH ENDS.)
   
      END      


      SUBROUTINE MDS_FOR(D, NVARY, V, T, GLOBALS)

      CHARACTER*120 CHFILE(6)
      INTEGER I, J 
      DOUBLE PRECISION D(*) 
      DOUBLE PRECISION FNCTN
      INTEGER NVARY, IERR
      DOUBLE PRECISION MU, THETA, STOPIT, SCALE, ALFA1, ALFA2
      DOUBLE PRECISION FMAX, FCUR, NORM, SIMPSIZE
      INTEGER IMAX, IMAXE
      DOUBLE PRECISION V( NVARY, * )
      DOUBLE PRECISION T( NVARY, * )
      DOUBLE PRECISION TEMP
      DOUBLE PRECISION DABS, DSQRT, DBLE
      INTEGER GLOBALS
      
      SAVE

      MU=2.0D0
      THETA=5.0D-1
      STOPIT=1.0D-5
      
      SCALE = 1.0
      DO 10 I=1,NVARY
        NORM=DABS(D(I))
        IF (NORM.GT.SCALE) SCALE=NORM
   10 CONTINUE
      ALFA1=SCALE/(NVARY*DSQRT(2.0D0))
      ALFA2=ALFA1
      ALFA1=ALFA1 * ( DSQRT( DBLE(NVARY) + 1.0D0 ) - 1.0D0 + NVARY )
      ALFA2=ALFA2 * ( DSQRT( DBLE(NVARY) + 1.0D0 ) - 1.0D0 )
      DO 20 I=1,NVARY
      V(I,1)=D(I)
   20 CONTINUE
C DEFINING THE INITIAL SIMPLEX      
      DO 50 J=2,NVARY+1
        DO 30 I=1,NVARY  
          IF (I.EQ.J-1) THEN
            V(I,J)=D(I)+ALFA1
          ELSE
            V(I,J)=D(I)+ALFA2
          END IF  
   30   CONTINUE
   50 CONTINUE
C  FINDING BEST VERTEX
      IMAX=1
      FMAX=FNCTN( D, IERR, GLOBALS )
      IF (IERR.EQ.1) GO TO 500
      DO 60 I=2,NVARY+1
        FCUR=FNCTN( V(1,I),IERR, GLOBALS )
        IF (IERR.EQ.1) GO TO 500
        IF (FCUR.GT.FMAX) THEN
           FMAX=FCUR
           IMAX=I
        END IF
   60 CONTINUE
      SIMPSIZE=0.0D0
      DO 80 J=2,NVARY+1
        NORM=0.0D0
        DO 70 I=1,NVARY
          NORM = NORM + DABS( V(I,J) - V(I,1) )
  70    CONTINUE
        IF (NORM.GT.SIMPSIZE) SIMPSIZE=NORM
  80  CONTINUE     
C MAIN LOOP
C-------------------------------------------
C PUT THE BEST VERTEX TO THE FIRST COLUMN   
  100 IF (IMAX.NE.1) THEN
        DO 110 I=1,NVARY
          TEMP=V(I,1)
          V(I,1)=V(I,IMAX)
          V(I,IMAX)=TEMP
  110   CONTINUE
        IMAX=1
      END IF
C CHECK STOPPING CRITERION
      NORM=0.0D0
      DO 150 I=1,NVARY
        NORM = NORM + DABS(V(I,1))
  150 CONTINUE
      IF (NORM.LT.1.0D0) NORM=1.0D0
      IF (SIMPSIZE/NORM.LT.STOPIT) GO TO 510
C ROTATION STEP
      DO 170 J=2,NVARY+1
        DO 160 I=1,NVARY
          T(I,J) = 2.0D0 * V(I,1) - V(I,J)
  160   CONTINUE
        FCUR=FNCTN( T(1,J), IERR, GLOBALS )
        IF (IERR.EQ.1) GO TO 500
        IF (FCUR.GT.FMAX) THEN
           FMAX=FCUR
           IMAX=J
        END IF
  170 CONTINUE
      IF (IMAX.NE.1) THEN
C EXPANSION STEP
        IMAXE=1
        DO 190 J=2,NVARY+1
          DO 180 I=1,NVARY
            V(I,J) = (1.0D0 - MU)*V(I,1) + MU*T(I,J)
  180     CONTINUE
          FCUR=FNCTN( V(1,J), IERR, GLOBALS )
          IF (IERR.EQ.1) GO TO 500
          IF (FCUR.GT.FMAX) THEN
            FMAX=FCUR
            IMAXE=J
          END IF
  190   CONTINUE
        IF (IMAXE.EQ.1) THEN
          DO 210 J=2,NVARY+1
            DO 200 I=1,NVARY
              V(I,J) = T(I,J)
  200       CONTINUE
  210     CONTINUE
        ELSE
          IMAX=IMAXE
          SIMPSIZE=SIMPSIZE*MU
        END IF
      ELSE
C CONTRACTION STEP
        DO 230 J=2,NVARY+1
          DO 220 I=1,NVARY
            V(I,J) = (1.0D0 + THETA)*V(I,1) - THETA*T(I,J)
  220     CONTINUE
          FCUR=FNCTN( V(1,J), IERR, GLOBALS )
          IF (IERR.EQ.1) GO TO 500
          IF (FCUR.GT.FMAX) THEN
            FMAX=FCUR
            IMAX=J
          END IF
  230   CONTINUE
        IF (IMAX.NE.1) SIMPSIZE=SIMPSIZE*THETA
      END IF
      GO TO 100               
  500 RETURN
  510 CHFILE(1)='INSUFFICIENT PROGRESS. SEARCH ENDS.'
      CALL KIIR(CHFILE, 1)
      GO TO 500
99999 FORMAT (/10X, 35HINSUFFICIENT PROGRESS. SEARCH ENDS.)
      END

