      SUBROUTINE ROUND2_FOR( VALUE, DERIVS, D, CONS, RHO, NOP, NLOP, 
     *              NOPER, NROP, NDXOUT, NVARY, NFIND, NPICK, 
     *              NERR, WGTLFT, WGTRGT, NDCOL, LIMITS, TOCOPY, A, B)
C THIS SUBROUTINE FINDS THE INTERMEDIATE COMPUTED VALUES PLUS THEIR
C PARTIAL DERIVATIVES WITH RESPECT TO THEIR ARGUMENTS.  A METHOD DUE TO
C JOHN LARSON AND AHMED SAMEH (EFFICIENT CALCULATION OF THE EFFECTS OF
C ROUNDING ERRORS, TOMS 4 (1978), PP. 228-236) IS
C APPLIED TO COMPUTE DELTAX(I,J), THE PARTIAL DERIVATIVE OF THE J-TH
C OUTPUT WRT THE I-TH INPUT, AND DERIVS(I,J), THE PARTIAL DERIVATIVE
C OF THE J-TH OUTPUT WRT THE I-TH COMPUTED VALUE.  IN STATEMENT 120
C DERIVS IS MODIFIED TO BE THE DERIVATIVE WRT THE I-TH ROUNDING ERROR.
C
      INTEGER LIMITS(*)
      INTEGER NOP(*)
      INTEGER NLOP(LIMITS(1),2), NOPER(LIMITS(1),2), 
     * NROP(LIMITS(1),2), NDXOUT(LIMITS(3),2), NVARY,
     * NERR, NFIND, NPICK, NDCOL(*)
      DOUBLE PRECISION D(*), DIJ, ONE, RHO, ARGL, ARGR, 
     * CONS(LIMITS(2),2),
     * HALF, ZERO, 
     * VALUE(NOP(3),2), DERIVS(NOP(3),NOP(4),2), WGTLFT(NOP(3),2), 
     * WGTRGT(NOP(3),2)
      DOUBLE PRECISION DSQRT
      INTEGER CSPONT, OUTSIZE, CONSIZE
      
      INTEGER TOCOPY;
      DOUBLE PRECISION A(NFIND, *), B(NFIND, *)
       
      INTEGER NALG, MOP, I, J, ILOP, MILOP, ILOPM, IOPER, IROP, MIROP
      INTEGER IROPM, JOUT, JOUTP, IBACK
      
      SAVE
      DATA ONE /1.0D0/, HALF /0.5D0/, ZERO /0.0D0/
C
      CSPONT=LIMITS(1)
      CONSIZE=LIMITS(2)
      OUTSIZE=LIMITS(3)
      NERR = 0
      DO 90 NALG=1,2
        MOP = NOP(NALG)
        DO 80 I=1,MOP
C COMPUTE THE I-TH VALUE AND ITS INPUT ARC WEIGHTS.
          ILOP = NLOP(I,NALG)
          MILOP = -ILOP
          IF (ILOP.LT.0) ARGL = CONS(MILOP,NALG)
          IF ((ILOP.GT.0) .AND. (ILOP.LE.NVARY)) ARGL = D(ILOP)
          ILOPM = ILOP - NVARY
          IF (ILOP.GT.NVARY) ARGL = VALUE(ILOPM,NALG)
          IOPER = NOPER(I,NALG)
          IF (IOPER.GT.4) GO TO 10
          IROP = NROP(I,NALG)
          MIROP = -IROP
          IF (IROP.LT.0) ARGR = CONS(MIROP,NALG)
          IF ((IROP.GT.0) .AND. (IROP.LE.NVARY)) ARGR = D(IROP)
          IROPM = IROP - NVARY
          IF (IROP.GT.NVARY) ARGR = VALUE(IROPM,NALG)
   10     GO TO (20, 30, 40, 50, 60, 70), IOPER
C ADDITION
   20     VALUE(I,NALG) = ARGL + ARGR
          WGTLFT(I,NALG) = ONE
          WGTRGT(I,NALG) = ONE
          GO TO 80
C SUBTRACTION
   30     VALUE(I,NALG) = ARGL - ARGR
          WGTLFT(I,NALG) = ONE
          WGTRGT(I,NALG) = -ONE
          GO TO 80
C MULTIPLICATION
   40     VALUE(I,NALG) = ARGL*ARGR
          WGTLFT(I,NALG) = ARGR
          WGTRGT(I,NALG) = ARGL
          GO TO 80
C DIVISION
   50     IF (ARGR.EQ.ZERO) GO TO 170
          VALUE(I,NALG) = ARGL/ARGR
          WGTLFT(I,NALG) = ONE/ARGR
          WGTRGT(I,NALG) = -VALUE(I,NALG)/ARGR
          GO TO 80
C SQUARE ROOT
   60     IF (ARGL.LE.ZERO) GO TO 180
          VALUE(I,NALG) = DSQRT(ARGL)
          WGTLFT(I,NALG) = HALF/VALUE(I,NALG)
          GO TO 80
C UNARY MINUS
   70     VALUE(I,NALG) = -ARGL
          WGTLFT(I,NALG) = -ONE
   80   CONTINUE
   90 CONTINUE
C
C COMPUTE THE PARTIAL DERIVATIVES.
      DO 150 NALG=1,2
        DO 140 J=1,NFIND
          JOUT = NDXOUT(J,NALG)
          DO 100 I=1,JOUT
            DERIVS(I,J,NALG) = ZERO
  100     CONTINUE
          DERIVS(JOUT,J,NALG) = ONE
          JOUTP = JOUT + 1
          DO 130 IBACK=1,JOUT
            I = JOUTP - IBACK
C I = NDXOUT(J), NDXOUT(J)-1, ..., 1
            DIJ = DERIVS(I,J,NALG)
            IF (DIJ.EQ.ZERO) GO TO 130
            ILOPM = NLOP(I,NALG) - NVARY
            IF (ILOPM.LE.0) GO TO 110
            DERIVS(ILOPM,J,NALG) = DERIVS(ILOPM,J,NALG) +
     *       WGTLFT(I,NALG)*DIJ
  110       IOPER = NOPER(I,NALG)
            IF (IOPER.GT.4) GO TO 120
            IROPM = NROP(I,NALG) - NVARY
            IF (IROPM.LE.0) GO TO 120
            DERIVS(IROPM,J,NALG) = DERIVS(IROPM,J,NALG) +
     *       WGTRGT(I,NALG)*DIJ
  120       DERIVS(I,J,NALG) = DIJ*VALUE(I,NALG)
C UNARY MINUS OPERATIONS ARE CONSIDERED ERROR-FREE.
            IF (IOPER.EQ.6) DERIVS(I,J,NALG) = ZERO
  130     CONTINUE
  140   CONTINUE
  150 CONTINUE
      IF ( TOCOPY.EQ.0 ) GO TO 159
      DO 154 I=1,NFIND
         JOUT = NDXOUT(I,1)
         JOUTP = JOUT + 1
         DO 152 J=1,JOUT
            A(I,J) = DERIVS(J,I,1)
  152    CONTINUE
         DO 153 J=JOUTP,NOP(1)
            A(I,J) = ZERO
  153    CONTINUE
  154 CONTINUE      
      DO 158 I=1,NFIND
         JOUT = NDXOUT(I,2)
         JOUTP = JOUT + 1
         DO 156 J=1,JOUT
            B(I,J) = DERIVS(J,I,2)
  156    CONTINUE
         DO 157 J=JOUTP,NOP(2)
            B(I,J) = ZERO
  157    CONTINUE
  158 CONTINUE      
  159 IF ((NPICK.GT.0) .AND. (NFIND.GT.1)) 
     * CALL OMEGA2( DERIVS, RHO, NDXOUT, NFIND, NPICK, NERR, NDCOL,
     * NOP, OUTSIZE )
      IF ((NPICK.LT.0) .OR. (NFIND.EQ.1)) 
     *   CALL GETER2( DERIVS, RHO, NDXOUT, NFIND, NPICK, NERR, 
     *   NOP, OUTSIZE)
  160 RETURN
C
C ATTEMPTED DIVISION BY ZERO.
  170 NERR = 1
      RHO = ZERO
      GO TO 160
C ATTEMPTED SQRT(V), V.LE.ZERO.
  180 NERR = 2
      RHO = ZERO
      GO TO 160
      END
C
C
C
C
      SUBROUTINE GETER2( DERIVS, RHO, NDXOUT, NFIND, NPICK, NERR, 
     *   NOP, OUTSIZE)
C
C
C THIS SUBROUTINE COMPUTES RHO = TOP/BOTTOM, WHERE TOP AND BOTTOM
C ARE THE FROBENIUS NORMS OF THE DERIVATIVES WRT ROUNDING ERRORS.
C
      INTEGER NOP(*), OUTSIZE
      INTEGER NDXOUT(OUTSIZE,2), NFIND, NPICK, NERR
      DOUBLE PRECISION RHO, TOP, ZERO, BOTTOM, DERIVS( NOP(3),NOP(4),2)
      DOUBLE PRECISION DSQRT
      
      INTEGER I, J, IOUT, INPICK
      
      SAVE
C
C FOR SINGLE PRECISION OMIT 'D0' FROM THE FOLLOWING CONSTANTS.
C ALSO CHANGE 'DSQRT'.
      DATA ZERO /0.0D0/
C
      TOP = ZERO
      BOTTOM = ZERO
      DO 30 I=1,NFIND
        IOUT = NDXOUT(I,1)
        DO 10 J=1,IOUT
          TOP = TOP + DERIVS(J,I,1)**2
   10   CONTINUE
        IOUT = NDXOUT(I,2)
        DO 20 J=1,IOUT
          BOTTOM = BOTTOM + DERIVS(J,I,2)**2
   20   CONTINUE
   30 CONTINUE
      INPICK = IABS(NPICK)
      IF ((INPICK.EQ.1) .AND. (BOTTOM.EQ.ZERO)) GO TO 50
      IF (INPICK.EQ.1) RHO = DSQRT(TOP/BOTTOM)
      IF ((INPICK.EQ.2) .AND. (TOP.EQ.ZERO)) GO TO 50
      IF (INPICK.EQ.2) RHO = DSQRT(BOTTOM/TOP)
   40 RETURN
   50 RHO = ZERO
      NERR = 3
      GO TO 40
      END
C
C
C
C
      SUBROUTINE OMEGA2( DERIVS, RHO, NDXOUT, NFIND, NPICK, NERR, NDCOL,
     * NOP, OUTSIZE )
C WE WILL USE THE NOTATION
C     A = DERIVATIVE OF THE OUTPUT WITH RESPECT TO ROUNDING ERRORS
C       IN ONE OF THE TEST METHODS.
C     B = DERIVATIVE OF THE OUTPUT WITH RESPECT TO ROUNDING ERRORS
C       IN THE OTHER TEST METHOD.
C THIS SUBROUTINE COMPUTES OMEGA(AK,BK), WHERE K DENOTES THE
C APPROPRIATE 2-NORM UNIT BALL.
      INTEGER OUTSIZE, NOP(*)
      DOUBLE PRECISION DERIVS(NOP(3),NOP(4),2),RHO,DENOM,HUGESV
     * ,T,TEN,TINYSV,TRY,ZERO
      INTEGER NDCOL(*), NDXOUT(OUTSIZE,2), NFIND, NPICK, NERR
      
      INTEGER NALG, NALG1, NALG2, I, J, NROWS, NDCOLJ, LIM
      INTEGER IERR
      
      SAVE
      DATA ZERO /0.0D0/, TEN /10.0D0/
C
C FIRST REDUCE A AND B TO SQUARE MATRICES BY APPLYING ORTHOGONAL
C TRANSFORMATIONS.
      DO 50 NALG = 1,2
         DO 10 J = 1,NFIND
            NDCOL(J) = NDXOUT(J,NALG)
   10       CONTINUE
         NROWS = NOP(NALG)
         IF (NROWS .LT. NFIND) GO TO 1001
         IF (NROWS .GT. NFIND) CALL
     *       SQUARE(DERIVS(1,1,NALG),NDCOL,NFIND,.TRUE., NOP(3) )
         IF (NROWS .GT. NFIND) GO TO 50
         DO 30 J = 1,NFIND
            NDCOLJ = NDCOL(J)
            IF (NDCOLJ .GE. NFIND) GO TO 30
            LIM = NDCOLJ + 1
            DO 20 I = LIM,NFIND
               DERIVS(I,J,NALG) = ZERO
   20          CONTINUE
   30       CONTINUE
   50    CONTINUE
C
C SECOND, DIAGONALIZE B. (ORTHOGONAL TRANSFORMATIONS IN THE
C OUTPUT SPACE MUST ALSO BE APPLIED TO A.) THEN FORM (B INVERSE)*A,
C UNLESS B IS SO ILL-CONDITIONED AS TO RENDER THE COMPUTATION
C MEANINGLESS
C
      NALG1 = NPICK
      NALG2 = 3 - NPICK
      CALL DIAGON(DERIVS(1,1,NALG2), DERIVS(1,1,NALG1), NFIND,.TRUE.,
     * IERR, NOP(3))
      IF (IERR .NE. 0) GO TO 1002
      IF (NFIND .EQ. 1) GO TO 108
      HUGESV = DERIVS(1,1,NALG2)
      TINYSV = HUGESV
      DO 104 J = 2,NFIND
         TRY = DERIVS(J,J,NALG2)
         IF (TRY .LT. TINYSV) TINYSV = TRY
         IF (TRY .GT. HUGESV) HUGESV = TRY
  104    CONTINUE
      T = TINYSV/TEN
      TRY = HUGESV + T
      IF (TRY .EQ. HUGESV) GO TO 1002
  108 DO 120 J = 1,NFIND
         DENOM = DERIVS(J,J,NALG2)
         DO 110 I = 1,NFIND
            DERIVS(I,J,NALG1) = DERIVS(I,J,NALG1)/DENOM
  110       CONTINUE
  120    CONTINUE
C
C THIRD (AND LAST), FIND THE SINGULAR VALUES OF (B INVERSE)*A.
C THE LARGEST IS OMEGA(AK,BK).
C
      CALL DIAGON(DERIVS(1,1,NALG1),DERIVS(1,1,NALG2),NFIND,.FALSE.,
     * IERR, NOP(3))
      IF (IERR .NE. 0) GO TO 1002
      RHO = DERIVS(1,1,NALG1)
      IF (NFIND .EQ. 1) RETURN
      DO 130 I = 2,NFIND
         TRY = DERIVS(I,I,NALG1)
         IF (TRY .GT. RHO) RHO = TRY
  130    CONTINUE
      RETURN
C
C THIS CODE IS REACHED IF EITHER ALGORITHM HAS FEWER ARITHMETIC
C OPERATIONS THAN THE NUMBER OF OUTPUTS.
 1001 NERR = 4
      RHO = ZERO
      RETURN
C
C THIS CODE IS REACHED IF OMEGA CAN NOT BE COMPUTED ACCURATELY.
 1002 NERR = 5
      RHO = ZERO
      RETURN
      END
C
C
C
C
C
C
C      SUBROUTINE POSITV(CONSTR, DATA, VALUE1, VALUE2, NBRCON)
C      DOUBLE PRECISION CONSTR(*), DATA(*), VALUE1(*), VALUE2(*)
C      NBRCON = 0
C      RETURN
C      END
C
