#include "CCompGraph.h"
#include <fstream>
using namespace std;


void CCompGraph::optimize( int mode )
        {
			if ( !m_bCounting )
			{
	            long *number = m_pManager->GetOptArray( m_nNOP );
                long i, j;
                long op;
				long noper;
				long datsizep = m_nDATSIZE + 1L;
                for( i = 0; i < m_nNOP; ++i )
                        number[i] = 0L;
                for( i = 0; i < m_nNFIND; ++i )
                        number[ m_pNDXOUT[i] - datsizep ] = 1L;
                for( i = m_nNOP - 1; i >= 0; --i )
                {
                        if ( number[i] )
                        {
                                op = m_pNLOP[i] - m_nDATSIZE;
                                if ( op > 0 )
                                        number[ op - 1 ] = 1L;
                                noper = m_pNOPER[i];
								if ( noper < 0 )
									noper = -noper;
                                if ( noper <= 4 )
                                {
                                        op = m_pNROP[i] - m_nDATSIZE;
                                        if ( op > 0 )
                                                number[ op - 1 ] = 1L;
                                }
                        }
                }
                j = 0;
                for( i = 0; i < m_nNOP; ++i )
                {
                        if ( number[i] )
                        {
                                number[i] = j;
                                op = m_pNLOP[ i ];
                                if ( op > m_nDATSIZE )
                                        op = number[ op - datsizep ] + datsizep;
                                m_pNLOP[ j ] =  op;

                                m_pNOPER[ j ] = m_pNOPER[i];

                                op = m_pNROP[ i ];
                                if ( op > m_nDATSIZE )
                                        op = number[ op - datsizep ] + datsizep;
                                m_pNROP[ j ] =  op;

                                ++j;
                        
                        }

                }
				op = ( mode == 1 ) ? datsizep : 1;
				for ( i = 0; i < m_nNFIND; ++i )
					m_pNDXOUT[i] = number[ m_pNDXOUT[i] - datsizep ] + op;

                m_nNOP = j;

			}
        }

/*
void CCompGraph::GenCodFile( char *fname )
{
        long i;
		int width = 5;
		long offset = 10000L;
		while ( m_nDATSIZE > offset )
		{
			offset *= 10L;
			++width;
		}
		offset -= m_nDATSIZE;


        ofstream CodFile( fname, ios::out );
        

        CodFile << ' ' << m_nNOP << '\n';
        
        for( i = 0; i < m_nNOP; ++i )
        {
                CodFile.width( width );
				if ( m_pNLOP[i] > m_nDATSIZE )
					CodFile << m_pNLOP[i] + offset;
				else
					CodFile << m_pNLOP[i];
                CodFile.width( 2 );
                CodFile << m_pNOPER[i] << ' ';
                CodFile.width( width );
				if ( m_pNROP[i] > m_nDATSIZE )
					CodFile << m_pNROP[i] +offset << '\n';
				else
					CodFile << m_pNROP[i] << '\n';
        }
        CodFile.width( 5 );
        
        CodFile << m_nNFIND << '\n';
        
        for( i = 0; i < m_nNFIND; ++i )
        {
                CodFile.width( 5 );
                CodFile << m_pNDXOUT[i] - m_nDATSIZE << '\n';
                
        }
        CodFile.width( 5 );
        CodFile << m_nNFIX << '\n';
        CodFile.setf( ios::scientific );
        for( i = 0; i < m_nNFIX; ++i )
        {
                CodFile.width( 5 );
                CodFile << m_pCONS[i] << '\n';
        }

}
*/


/*
CCompGraph::CCompGraph( CGraphManager *pManager ) 

        {
                m_pManager = pManager;
	
				m_pManager->GetLimits( m_nCSPONT, m_nDATSIZE, m_nCONSIZE, m_nOUTSIZE );

                m_nNOP = m_nNFIND = m_nNFIX = m_nNVARY = 0L;
                m_nZero = m_nOne = 0L;

				m_pManager->GetOperations( m_pNLOP, m_pNOPER, m_pNROP );
				m_pManager->GetPointers( m_pNDXOUT, m_pCONS, m_pD );

				m_bCounting = ( m_nCSPONT == 0L );
				m_bVariable = false;
				m_bCompo = false;
				m_nCompoIndex = 0L;

//                m_nNTOP = 0L;
//                m_nState = 0;
      
        }

*/		

long CCompGraph::ComputeNtop( void ) const
		{
			long i;
			int iioper;
			long ntop = 0L;
			for ( i = 1; i <= m_nNOP; ++i )
			{
				iioper = m_pNOPER[ i - 1 ];
				if ( i == 1 && iioper < 0 )
					ntop = -1L;
				if ( ntop == -1L && iioper > 0 )
					ntop = i;
				if ( ntop == 0L && i > 1 && iioper < 0 )
					ntop = 1L;
			}

			if ( ntop > 0L )
				ntop = ntop + m_nNVARY;
			return ntop;
		}


