#ifndef _CCOMP_GRAPH_
#include "CGraphManager.h"
#ifndef _CCOMP_GRAPH_
#define _CCOMP_GRAPH_



class CCompGraph
{
private:
//        int m_nState;

//        long m_nNTOP;
        
        
        
        long m_nCSPONT;
        long m_nDATSIZE;
        long m_nCONSIZE;
        long m_nOUTSIZE;

        long m_nNOP;
        long m_nNFIND;
        long m_nNFIX;
        long m_nNVARY;
        
        long *m_pNLOP;
        long *m_pNOPER;
        long *m_pNROP;
        long *m_pNDXOUT;
        double *m_pCONS;

        double *m_pD;

        
		long m_nZero;
        long m_nOne;

		CGraphManager *m_pManager;

		bool m_bCounting;
		bool m_bVariable;
		bool m_bCompo;

		long m_nCompoIndex;

        friend class CGraphPtr;

/*
        void selfinit( const CCompGraph& other );


        
		long* duplicate( long& OldSize, long NewSize, long* DataArray, long ActSize );

		double* duplicate( long& OldSize, long NewSize, double* DataArray, long ActSize );
*/

		void DuplConst( void )
		{
			m_pManager->duplicate( m_nCONSIZE, m_pCONS, m_nNFIX );
		}

		void DuplOutput( void )
		{
			m_pManager->duplicate( m_nOUTSIZE, m_pNDXOUT, m_nNFIND );
		}

		void DuplNodes( void )
		{
			m_pManager->duplicate( m_nCSPONT, m_pNLOP, m_pNOPER, m_pNROP, m_nNOP );
		}


public:
        

        void GenCodFile( char *fname );
        
        void optimize( int mode );


        CCompGraph( CGraphManager *pManager )
		{
			m_pManager = pManager;
		}

		const CGraphManager &GetManager( void ) const
		{
			CAssert::NotNull( m_pManager );
			return *m_pManager;
		}

		CGraphManager &GetManager( void )
		{
			CAssert::NotNull( m_pManager );
			return *m_pManager;
		}


		void attach( CGraphManager *pManager )
		{
			m_pManager = pManager;
			m_pManager->GetOperations( m_pNLOP, m_pNOPER, m_pNROP );
			m_pManager->GetPointers( m_pNDXOUT, m_pCONS, m_pD );
		}

		void reset( bool CountAllowed = true )
		{
				m_pManager->GetLimits( m_nCSPONT, m_nDATSIZE, m_nCONSIZE, m_nOUTSIZE );

                m_nNOP = m_nNFIND = m_nNFIX = m_nNVARY = 0L;
                m_nZero = m_nOne = 0L;

				m_pManager->GetOperations( m_pNLOP, m_pNOPER, m_pNROP );
				m_pManager->GetPointers( m_pNDXOUT, m_pCONS, m_pD );

				m_bCounting = CountAllowed && ( m_nCSPONT == 0L );
				m_bVariable = false;
				m_bCompo = false;
				m_nCompoIndex = 0L;
		}

    	void GetSizes( long &nop, long &nvary, long &nfind, long &nfix ) const
		{
			nop = m_nNOP;
			nvary = m_nNVARY;
			nfind = m_nNFIND;
			nfix = m_nNFIX;
		}
		
		bool IsVar( void ) const
		{
			return m_bVariable;
		}

		bool IsCounting( void ) const
		{
			return m_bCounting;
		}


		long ComputeNtop( void ) const;








 

};

#endif
#endif