#include "CConstraints.h"
#include "miller.h"
#include <stdio.h>

CConstraints::CConstraints( const CConstraints &other )
{
		selfinit( other );
		
}

CConstraints &CConstraints::operator=( const CConstraints &other )
{
		if ( this == &other )
			return *this;

		delete [] m_pC;
		selfinit( other );
		return *this;
}

void CConstraints::selfinit( const CConstraints &other )
{
		nullinit();
	    m_nSize = other.m_nSize;
		if ( other.m_nLimit > 0 )
		{
			long i;
			m_pC = new double[ other.m_nSize ];
			m_nLimit = other.m_nSize;
			for ( i = 0; i < m_nSize; ++i )
				m_pC[i] = other.m_pC[i];
		}
		m_bValid = other.m_bValid;
		m_dPenalty = other.m_dPenalty;
}


void CConstraints::InitSpace( long size, bool lengthen )
{
		if ( size < m_nSize )
			size = m_nSize;
		if ( size > m_nLimit )
		{
			if ( lengthen )
			{
				long i;
				double *ptr;
				ptr = new double[ size ];

				for ( i = 0; i < m_nSize; ++i )
					ptr[i] = m_pC[i];
				delete [] m_pC;
				m_pC = ptr;
			}
			else
			{
				delete [] m_pC;
				m_pC = 0;
				m_pC = new double[ size ];
				m_nSize = 0L;
			}
			m_nLimit = size;

		}
		else if ( !lengthen )
		{
			m_nSize = 0L;
		}
}

void CConstraints::ReportConstraints( void ) const
{
	 char OutStr[256];
	 long i;
     if ( m_nSize > 0 )
     {
		 sprintf( OutStr, "The constraints are:\n" );
         mPrint( OutStr );
         for( i = 0; i < m_nSize; ++i )
		 {
			 sprintf( OutStr, "C( %d ) = %e\n", i, m_pC[i] );
             mPrint( OutStr );
		 }
         sprintf( OutStr, "\n" );
         mPrint( OutStr );
	 }
	 else
     {
		 sprintf( OutStr, "There are no constraints\n\n" );
         mPrint( OutStr );
	 }
}

double CConstraints::GetPenalty( void )
	{
		if ( !m_bValid )
		{
			long i;
			m_dPenalty = 1.0;
			for( i = 0; i < m_nSize; ++i )
			{
				if ( m_pC[i] < m_dPenalty )
					m_dPenalty = m_pC[i];
			}
			m_bValid = true;
		}
		return m_dPenalty;
	}

void CConstraints::GetConstraints( double *pCopy )
	{
		long i;
		for ( i = 0; i < m_nSize; ++i )
			pCopy[i] = m_pC[i];
	}
