#ifndef _CCONSTR_
#define _CCONSTR_



class CConstraints
{
private:
	double *m_pC;
	long m_nLimit;
	long m_nSize;
	double m_dPenalty;
	bool m_bValid;

	void nullinit( void )
	{
		m_pC = 0;
		m_nLimit = m_nSize = 0L;
		m_dPenalty = 1.0;
		m_bValid = true;
	}

	void selfinit( const CConstraints &other );

public:
	CConstraints( void )
	{
		nullinit();
	}

	~CConstraints( void )
	{
		delete [] m_pC;
	}

	CConstraints( const CConstraints &other );

	CConstraints &operator=( const CConstraints &other );

	void InitSpace( long size = 0L, bool lengthen = false );

	void insert( double constr )
	{
		
		if ( m_nLimit != 0L )
		{
			if ( m_nSize == m_nLimit )
				InitSpace( 2 * m_nLimit, true );
			m_pC[ m_nSize ] = constr;
			m_bValid = false;
		}
		++m_nSize;
	}

	long GetSize( void ) const
	{
		return m_nSize;
	}
	double *GetPtr( long number )
	{
		m_bValid = false;
		InitSpace( m_nSize + number, true );
		return m_pC + m_nSize;
	}

	double GetPenalty( void );

	void ReportConstraints( void ) const;

	void GetConstraints( double *pCopy );

	long GetMemAlloc( void ) const
	{
		return m_nLimit * sizeof( double );
	}

	long GetMemUsed( void )
	{
		return m_nSize * sizeof( double );
	}

};

		




#endif