#include "CException.h"
#include "CGlobals.h"

void mTerminate( const char *szoveg );
#include "miller.h"




void CException::FinalHandler( CGlobals *pGlobals, bool terminate )
{
	if ( m_pErrMsg != 0 )
	{
		char ErrText[ 512 ];
		if ( m_Error == other_error && terminate )
		{
			strncpy( ErrText, m_pErrMsg, 510 );
			ErrText[511] = '\0';
			delete [] m_pErrMsg;
			m_pErrMsg = 0;
//			if ( pGlobals != 0 )
//				pGlobals->ClearEngine();
			mTerminate( ErrText );
		}
		delete [] m_pErrMsg;
		m_pErrMsg = 0;
	}
}

void CException::mError( const char *ErrMsg )
{
	CException except( ErrMsg );
	delete [] m_pErrMsg;
	m_pErrMsg = 0;
	throw except;
}

void CException::cHandler( const char *szoveg )
{
		if ( m_Mode == search )
			mWarning( szoveg );
		else 
			mError( szoveg );
}


int CException::handler( CGlobals &globals )
	{
		globals.IncErrorCounter( m_Error );
		m_Mode = globals.GetMode();
		if ( m_Error >= div_by_zero && m_Error <= user_error )
		{
			if ( globals.GetMode() != normal )
			{
				return 0;
			}
			else
			{
				switch ( m_Error )
				{
				case div_by_zero:
					mError( "\nDivision by zero attempted!\n" );
					break;
				case sqrt_neg:
					mError( "\nAttempted to take the square root of a negative number!\n" );
					break;
				case geter:
					mError( "\nGETER failure!\n" );
					break;
				case omega:
					mError( "\nOMEGA failure!\n" );
					break;
				case diagon:
					mError( "\nDIAGON failure!\n" );
					break;
				case condit:
					mError( "\nCONDIT failure!\n" );
					break;
				case cholesky:
					mError( "\nCHOLESKY failure!\n" );
					break;
				case geneig:
					mError( "\nGENEIG failure!\n" );
					break;
				case tridiagon:
					mError( "\nTRIDIAGON failure!\n" );
					break;
				case eigen:
					mError( "\nEIGEN failure!\n" );
					break;
				case user_error:
					mError( "\nUser error!\n" );
					break;
				}
				return 1;
			}
		}
		else if ( m_Error >= input_too_large && m_Error <= no_operation )
		{
			
			if ( m_Mode == search )
			{
//				cHandler = mWarning;
				if ( m_pErrMsg != 0 )
				{
					if ( m_Error == other_error )
						mWarning( m_pErrMsg );
					delete [] m_pErrMsg;
					m_pErrMsg = 0;
				}
			}
			else
			{
//				cHandler = mError;
				if ( m_pErrMsg != 0 )
				{
					if ( m_Error == other_error )
						throw;
					delete [] m_pErrMsg;
					m_pErrMsg = 0;
				}
			}

	      
		  
		  	
			switch ( m_Error )
			{
			case input_too_large:
				cHandler( "Input size mismatch!\n" );
				break;
			case input_too_large_1:
				cHandler( "Input size mismatch in the first algorithm!\n" );
				break;
			case input_too_large_2:
				cHandler( "Input size mismatch in the second algorithm!\n" );
				break;
			case no_output:
				cHandler( "The algorithm has no output!\n" );
				break;
			case no_output_1:
				cHandler( "The first algorithm has no output!\n" );
				break;
			case no_output_2:
				cHandler( "The second algorithm has no output!\n" );
				break;
			case div_by_con0:
				cHandler( "Division by constant zero!\n" );
				break;
			case sqrt_con_neg:
				cHandler( "Taking the square root of a negative constant!\n" );
				break;
			case illegal_output:
				cHandler( "Output must be intermediate value!\n" );
				break;
			case comp_error_free:
				cHandler( "By comparing error free operations are not permitted!\n" );
				break;
			case invalid_par_index:
				cHandler( "Parameter index is out of range!" );
			case diff_input_num:
				cHandler( "The two algorithms have different number of inputs!\n" );
				break;
			case diff_output_num:
				cHandler( "The two algorithms have different number of outputs!\n" );
				break;
			case no_operation:
				cHandler( "There is not any operation in the computational graph!\n" );
				break;
			case no_operation_1:
				cHandler( "There is not any operation in the computational graph of the first algorithm!\n" );
				break;
			case no_operation_2:
				cHandler( "There is not any operation in the computational graph of the second algorithm!\n" );
				break;
			case multiple_comp_call:
				cHandler( "Composition called more than once!\n" );
				break;
			case invalid_constr_call:
				cHandler( "Invalid constructor call!\n" );
				break;
			case user_terror:
				cHandler( "User error!\n" );
				break;
			}
			
			return 1;
		}
		else if ( m_Mode == search )
		{
			char OutStr[256];
			if ( m_Error == instability_located )
			{
						
					sprintf( OutStr, "\n\n !!!Instability located!!! \
					\n\n After %d evaluations the error measuring number: %e\n\n",
                                m_nNCALLS + 1, m_dRHO );
					mPrint( OutStr );
							
				return -1;
			}
			else if ( m_Error == report_process )
			{
				if ( m_bNPRINT )
				{
					sprintf( OutStr,
"\n Column 1 gives the number of evaluations,\n column 2 gives the current error measuring value.\n" );
                mPrint( OutStr );
				}
				sprintf( OutStr, "%15d %15.6e", m_nNCALLS, m_dRHO );
				mPrint( OutStr );
				return 0;
			}
			else if ( m_Error == call_limit_exceeded )
			{
				mPrint( "\nCall limit exceeded!\n" );
			

				return -1;
			}
		}
		return 0;
		
	}


