#ifndef _CEXCEPTION_
#define _CEXCEPTION_
#include <stdio.h>
#include <string.h>
//#include <assert.h>
class CGlobals;

#include <miller_enum.h>

class CException
{
private:
	enum err m_Error;
//	static long m_pNERR[6];
//	static EnumMode m_Mode;

	long m_nNCALLS;
	double m_dRHO;
	bool m_bNPRINT;
	char* m_pErrMsg;
	enum EnumMode m_Mode;

	void cHandler( const char *szoveg );

	
public:
	CException( enum err Error = other_error, long calls = 0, double rho = 0.0, bool print = false ) : 
	  m_Error( Error ), m_nNCALLS( calls ), m_dRHO( rho ), m_bNPRINT( print ), m_pErrMsg( 0 )
	{
		
	}

	CException( const char *ErrMsg ) : m_Error( other_error )
	{
		m_pErrMsg = new char[ strlen( ErrMsg) + 1 ];
		strcpy( m_pErrMsg, ErrMsg );
	}
	

	




/*	void SetMode( EnumMode mode )
	{
		m_Mode = mode;
	}
*/
//	void ClearErr( void );

//	void ListExceptions( void );

/*	bool IsSearch( void )
	{
		return m_Mode != normal;
	}

*/
	int handler( CGlobals &globals );

	void FinalHandler( CGlobals *pGlobals = 0, bool terminate = true );

	void mError( const char *ErrMsg );

	enum err ErrorCode( void )
	{
		return m_Error;
	}

	
	


};

class CAssert
{
private:
	int ErrorCode;

public:
	static const int DEBUG_ERROR = 1;
	
	CAssert( void ) : ErrorCode( 1 )
	{
		
	}

	inline static bool Assert( bool assertion )
	{
		if ( !assertion )
			CAssert();
		return true;
	}
    
	template <class T1, class T2>
	inline static void EQ( T1 a, T2 b )
	{
		if ( DEBUG_ERROR && a != b )
			throw CAssert();
	}

	template <class T1>
	inline static void Null( T1 a )
	{
		if ( DEBUG_ERROR && a )
			throw CAssert();
	}

	template <class T1>
	inline static void NotNull( T1 a )
	{
		if ( DEBUG_ERROR && !a )
			throw CAssert();
	}

};
/*
template <int TOLOG = 0>
class CLog;

template <>
class CLog<0>
{
};

template <>
class CLog<1>
{
};
*/
#endif

