#include "CGraphPtr.h"

CGraphPtr CGraphPtr::insert( double *RValue )
	{
		
		if ( m_pTheGraph->m_nNVARY < m_pTheGraph->m_nDATSIZE )
		{
			long i = ( m_pTheGraph->m_nNVARY )++;
			*RValue = ( m_pTheGraph->m_pD )[i];
			return CGraphPtr( i + 1 );
		}
		else
			throw CException( input_too_large ); 

	}

CGraphPtr CGraphPtr::insert( const double constant )
	{
		long i = 0;
		long index;
		while ( i < m_pTheGraph->m_nNFIX && (m_pTheGraph->m_pCONS)[i] != constant )
			++i;
		if ( i == m_pTheGraph->m_nNFIX )
		{
			if ( m_pTheGraph->m_nNFIX >= m_pTheGraph->m_nCONSIZE )
			    m_pTheGraph->DuplConst();
			
			index = ++( m_pTheGraph->m_nNFIX );
			if ( m_pTheGraph->m_nZero == 0 && constant == 0.0 )
				m_pTheGraph->m_nZero = index;
			if ( m_pTheGraph->m_nOne == 0 && constant == 1.0 )
				m_pTheGraph->m_nOne = index;
			( m_pTheGraph->m_pCONS )[ index-1 ] = constant;
			return CGraphPtr( -index );
		}
		else
			return CGraphPtr( -(i+1) );
	}

CGraphPtr CGraphPtr::insert( CGraphPtr left, enum operation op, CGraphPtr right )
	{
		long index;
		long nBackIndex;
		long *pNOPER;

		if ( -left.m_nIndex == m_pTheGraph->m_nZero )
		{
			if ( op == add )
				return right;
			else if ( op == sub )
			{
				if ( -right.m_nIndex == m_pTheGraph->m_nZero )
					return right;
				left = right;
				op = neg;
			}
			else 
				return left;
		}
		else if ( -left.m_nIndex == m_pTheGraph->m_nOne )
		{
			if ( op == mul )
				return right;
			if ( op == sqroot )
				return left;
		}
		if ( op < sqroot )
		{
			if ( -right.m_nIndex == m_pTheGraph->m_nZero )
			{
				if ( op <= sub )
					return left;
				if ( op == mul )
					return right;
				if ( op == per )
					throw CException( div_by_con0 );
			}
			else if ( -right.m_nIndex == m_pTheGraph->m_nOne )
			{
				if ( op == mul || op == per )
					return left;
			}
		}
		

		if ( !m_pTheGraph->m_bCounting )
		{

			if ( m_pTheGraph->m_nNOP >= m_pTheGraph->m_nCSPONT )
				m_pTheGraph->DuplNodes();

			index = ++( m_pTheGraph->m_nNOP );
			( m_pTheGraph->m_pNLOP )[ index-1 ] = left.m_nIndex;
			if ( m_pTheGraph->m_bCompo && left.m_nIndex > m_pTheGraph->m_nDATSIZE )
			{
				nBackIndex = left.m_nIndex - m_pTheGraph->m_nDATSIZE - 1;
				if ( nBackIndex < m_pTheGraph->m_nCompoIndex )
				{
					pNOPER = m_pTheGraph->m_pNOPER + nBackIndex;
					if ( *pNOPER < 0 )
						*pNOPER = -(*pNOPER);
				}
			}

			( m_pTheGraph->m_pNOPER )[ index-1 ] = m_pTheGraph->m_bCompo ? -int(op) : int(op);

			if ( op < sqroot )
			{
				( m_pTheGraph->m_pNROP )[ index-1 ] = right.m_nIndex;
				if ( m_pTheGraph->m_bCompo && right.m_nIndex > m_pTheGraph->m_nDATSIZE )
				{
					nBackIndex = right.m_nIndex - m_pTheGraph->m_nDATSIZE - 1;
					if ( nBackIndex < m_pTheGraph->m_nCompoIndex )
					{
						pNOPER = m_pTheGraph->m_pNOPER + nBackIndex;
						if ( *pNOPER < 0 )
							*pNOPER = -(*pNOPER);
					}
				}
			}

			else
				( m_pTheGraph->m_pNROP )[ index-1 ] = 0L;
		}
		else
		{
			index = ++( m_pTheGraph->m_nNOP );
		}

		return CGraphPtr( index + m_pTheGraph->m_nDATSIZE );

	}

void CGraphPtr::output( void ) const
	{
		long i = 0L;
		long index = m_nIndex;
		if ( index <= m_pTheGraph->m_nDATSIZE )
			throw CException( illegal_output );
		if ( m_pTheGraph->m_bCounting )
		{
			++m_pTheGraph->m_nNFIND;
			return;
		}
		while ( i < m_pTheGraph->m_nNFIND && ( m_pTheGraph->m_pNDXOUT )[i] != index )
			++i;
		if ( i == m_pTheGraph->m_nNFIND )
		{
			if ( i >= m_pTheGraph->m_nOUTSIZE )
				m_pTheGraph->DuplOutput();
			
			++m_pTheGraph->m_nNFIND;
			( m_pTheGraph->m_pNDXOUT )[i] = index;
		}
		if ( m_pTheGraph->m_bCompo )
		{
			long nBackIndex;
			long *pNOPER;

			nBackIndex = index - m_pTheGraph->m_nDATSIZE - 1;
			if ( nBackIndex < m_pTheGraph->m_nCompoIndex )
			{	
				pNOPER = m_pTheGraph->m_pNOPER + nBackIndex;
				if ( *pNOPER < 0 )
					*pNOPER = -(*pNOPER);
			}
		}
	}

void CGraphPtr::composition( void )
{
	long i;
	long nop;
	long *pnoper;
	if ( m_pTheGraph->m_bCompo )
		throw CException( multiple_comp_call );
	nop = m_pTheGraph->m_nNOP;
	if ( !m_pTheGraph->m_bCounting )
	{
		pnoper = m_pTheGraph->m_pNOPER;
		for( i = 0; i < nop; ++i )
		{
			if ( pnoper[i] > 0 )
				pnoper[i] = -pnoper[i];
		}
	}
	m_pTheGraph->m_bCompo = true;
	m_pTheGraph->m_nCompoIndex = nop;
}
