#include "CGlobals.h"

double CRoundBase::round( double *input, double &penalty, CGlobals &globals )
{
	double rho;
	globals.SetConstr( &m_Constr );
	rho = SpecRound( input, globals );
	penalty = m_Constr.GetPenalty();
	if ( penalty > 0 && rho > m_dSTOPX && m_dSTOPX > 0 )
		throw CException( instability_located, m_nNCALLS, rho );
	return rho;
}

bool CRoundBase::FillBegin( double *input, CGlobals &globals )
{
	globals.SetConstr( &m_Constr );
	return false;
}

void CRoundBase::FillEnd( CGlobals &globals )
{
}

double CRoundBase::ComputeRho( double &penalty, CGlobals &globals )
{
	penalty = m_Constr.GetPenalty();
	double rho = GetRho();
	if ( penalty > 0 && rho > m_dSTOPX && m_dSTOPX > 0 )
		throw CException( instability_located, m_nNCALLS, rho );
	return rho;
}

CRoundBase::~CRoundBase( void )
{
}
