#include "CUkkonenA.h"

void CUkkonenA::GetMatrices( double *A, double *B )
{
	long j;
	long i;
	long count_j = 0L;
	long count_i = 0L;
	long index1;
	long index2;
	CUkkonenCol *i_ptr;
	CUkkonenCol *j_ptr;
	long n;
	n = CUkkonen::GetOutSize();


	for ( j = m_Wmatrix.InitIndex(); j > 0L; j = m_Wmatrix.AdvanceIndex( j ) )
	{
		if ( ( j_ptr = &m_Wmatrix.GetVariable( j ) )->IsOutput() )
		{
			count_j = j_ptr->GetKind() - 1;
			for ( i = m_Wmatrix.InitIndex(); i > 0L && i < j; i = m_Wmatrix.AdvanceIndex( i ) )
			{
				if ( ( i_ptr = &m_Wmatrix.GetVariable( i ) )->IsOutput() )
				{
					count_i = i_ptr->GetKind() - 1;
					index1 = count_j * n + count_i;
					index2 = count_i * n + count_j;
					A[ index1 ] = A[ index2 ] = m_Wmatrix.AAT( i, j );
	

				}
			}
			count_i = ( m_Wmatrix.GetVariable( i ) ).GetKind() - 1;
			if ( i != j || count_i != count_j )
				throw CException( "i!=j in CUkkonenA::GetMatrices" );
			index1 = count_i * n + count_i;
			A[ index1 ] = m_Wmatrix.AAT( i, i );

		}
	}
}

double *CUkkonenA::GetPackedB( void )
{
	return 0;
}



void CUkkonenA::KahanCorrection( void )
{
	return;
}

void CUkkonenA::CndNumCorrection( void )
{
	return;
}
/*
long CUkkonenA::input( double *value )
{
	long i;
	long j;
	CUkkonenCol &variable = m_Wmatrix.GetVariable( i = m_Wmatrix.Require() );

	if( m_nInputCounter >= m_nDATSIZE )
		throw CException( input_too_large );

	
	if ( !variable.IsConst() )
	{
			for ( j = m_Wmatrix.InitIndex(); j > 0L && j < i; j = m_Wmatrix.AdvanceIndex( j ) )
				m_Wmatrix.AAT( j, i ) =  0.0;
			if ( i != j )
				throw CException( "i!=j in CUkkonen::input." );
			m_Wmatrix.AAT( i, j ) = 0.0;
			j = m_Wmatrix.AdvanceIndex( j );
			for ( ; j > 0L; j = m_Wmatrix.AdvanceIndex( j ) )
				m_Wmatrix.AAT( i, j ) = 0.0;
	}
	variable.MarkAsInput();
	*value = m_pDATA[ m_nInputCounter++ ];
	return i;

}
*/
void CUkkonenA::update( long i, long j,  double alpha, double z, long l, double beta )
{
	long t;
	double alpha2;
	if ( alpha == 0.0 )
	{
		t = j;
		j = l;
		l = t;
		alpha = beta;
		beta = 0.0;
	}
	alpha2 = alpha * alpha;
	if ( beta != 0.0 )
	{
		double beta2 = beta * beta;
		double albe2 = 2 * alpha * beta;

		for ( t = m_Wmatrix.InitIndex(); t > 0L && t < i; t = m_Wmatrix.AdvanceIndex( t ) )
		{
			m_Wmatrix.AAT( t, i ) = alpha * m_Wmatrix.AAT( j, t ) + beta * m_Wmatrix.AAT( l, t );
		}
		if ( i != t )
			throw CException( "i!=t in CUkkonen::update." );
		m_Wmatrix.AAT( i, i ) = alpha2 * m_Wmatrix.AAT( j, j ) + beta2 * m_Wmatrix.AAT( l, l ) + 
			z + albe2 * m_Wmatrix.AAT( j, l );
		t = m_Wmatrix.AdvanceIndex( t );
		for ( ; t > 0L; t = m_Wmatrix.AdvanceIndex( t ) )
		{
			m_Wmatrix.AAT( i, t ) = alpha * m_Wmatrix.AAT( j, t ) + beta * m_Wmatrix.AAT( l, t );
		}
	}
	else
	{
		for ( t = m_Wmatrix.InitIndex(); t > 0L && t < i; t = m_Wmatrix.AdvanceIndex( t ) )
		{
			m_Wmatrix.AAT( t, i ) = alpha * m_Wmatrix.AAT( j, t );
		}
		if ( i != t )
			throw CException( "i!=t in CUkkonen." );
		m_Wmatrix.AAT( i, i ) = alpha2 * m_Wmatrix.AAT( j, j ) + z;
		t = m_Wmatrix.AdvanceIndex( t );
		for ( ; t > 0L; t = m_Wmatrix.AdvanceIndex( t ) )
		{
			m_Wmatrix.AAT( i, t ) = alpha * m_Wmatrix.AAT( j, t );
		}
	}
}

