#ifndef _CUKKONENCOL_
#define _CUKKONENCOL_


#include "CException.h"
enum kind{ input = -3, constant, intermediate };

class CUkkonenCol
{

protected:

	long m_nRefCounter;
	long m_nIndex;
	long m_kind;
	double m_dValue;
	CUkkonenCol *m_pNext;
	double *A;
	double *B;

public:
	CUkkonenCol()
	{
        m_nRefCounter = 0L;
		m_nIndex = 0L;
		m_kind = constant;
		m_dValue = 0.0;
		m_pNext = 0;
		A = 0;
		B = 0;

	}
//	CUkkonenCol &DeepCopy( const CUkkonenCol &other );
		
/*
    void InitA( long index, double *pA )
	{
		m_nIndex = index;
		A = pA;
	}
*/  
  void Init( long index, double *pA, double *pB = 0 )
	{
		m_nIndex = index;
		A = pA;
		B = pB;
	}


	void IncRefCounter( void )
	{
		++m_nRefCounter;
	}

	bool DecRefCounter( void )
	{
		if ( m_nRefCounter > 0L )
			--m_nRefCounter;
		return m_nRefCounter == 0;
	}
	void ResetRefCounter( void )
	{
		m_nRefCounter = 0L;
	}

/*	void DestroyArray( void )
	{
		A = 0;
		B = 0;
	}
*/
	
    


	void MarkAsInput( void )
	{
		m_kind = input;
	}
	void MarkAsConst( void )
	{
		m_kind = constant;
	}

	void MarkAsInterm( void )
	{
		m_kind = intermediate;
	}
	void MarkAsOutput( long index )
	{
		m_kind = index;
	}

	long GetKind( void )
	{
		return m_kind;
	}

	void SetKind( long par )
	{
		m_kind = par;
	}


	bool IsInput( void )
	{
		return m_kind == input;
	}
	bool IsConst( void )
	{
		return m_kind == constant;
	}
	bool IsInterm( void )
	{
		return m_kind == intermediate;
	}
	bool IsOutput( void )
	{
		return m_kind > 0;
	}




	CUkkonenCol *GetNext( void )
	{
		return m_pNext;
	}

	void ClearNext( void )
	{
		m_pNext = 0;
	}

	void SetNext( CUkkonenCol &other )
	{
		m_pNext = &other;
	}

	CUkkonenCol *InsertAfter( CUkkonenCol &other )
	{
		other.m_pNext = m_pNext;
		m_pNext = &other;
		return &other;
	}

	CUkkonenCol *OutFromAfter( void )
	{
		CUkkonenCol *ptr;
		ptr = m_pNext;
		if ( m_pNext != 0 )
			m_pNext = m_pNext->m_pNext;
		return ptr;
	}

	double &GetA( long index )
	{
		if ( index <= 0 || index > m_nIndex || A == 0 )
			throw CException( "Index out of range in CUkkonenCol." );
		return A[ index - 1 ];
	}

	double &GetB( long index )
	{
		if ( index <= 0 || index > m_nIndex || B == 0 )
			throw CException( "Index out of range in CUkkonenCol." );
		return B[ index - 1 ];
	}
	
	long GetIndex( void )
	{
		return m_nIndex;
	}

	double GetValue( void )
	{
		return m_dValue;
	}

	void SetValue( double value )
	{
		m_dValue = value;
	}


	
};

#endif
