#ifndef _CUKKONENGRAPH_
#define _CUKKONENGRAPH_

#include "CUkkonen.h"
#include "CUGraphManager.h"

class CUkkonenGraph : public virtual CUkkonen
{
private:
	CUGraphManager m_TheGraph;

	long *m_pLeftValue;
	long m_nNodeSize;

	long *m_pConstLeftValue;
	long m_nConSize;
/*
	void SelfInit( const CUkkonenGraph &other )
	{
		long nvary;
		long nop;
		long nfix;

		long nodesize;


		m_TheGraph.GetSizes( nop, nvary, nodesize, nfix );
		nodesize = nop + nvary;
		m_pLeftValue = new long[ nodesize ];
		m_pConstLeftValue = new long[ nfix ];

		m_nNodeSize = nodesize;
		m_nConSize = nfix;
	}
*/
	void nullinit( void )
	{
		m_nNodeSize = 0L;
		m_pLeftValue = 0;
		m_pConstLeftValue = 0;
		m_nConSize = 0L;
	}

protected:
	virtual void RunAlgorithm( int AlgIndex, CGlobals &globals );
public:
	CUkkonenGraph( double *pDATA, long nDATSIZE, long nNPICK ) : CUkkonen( pDATA, nDATSIZE, nNPICK ),
		m_TheGraph( pDATA, nDATSIZE )
	{	
		nullinit();
	}

	CUkkonenGraph( const CUkkonenGraph &other ) : CUkkonen( other ), 
		m_TheGraph( other.m_TheGraph )
	{
		nullinit();
	}

	CUkkonenGraph &operator=( const CUkkonenGraph &other )
	{
		if ( this == &other )
			return *this;
		CUkkonen::operator=( other );
		m_TheGraph = other.m_TheGraph;
		delete [] m_pLeftValue;
		delete [] m_pConstLeftValue;
		nullinit();

	}


	~CUkkonenGraph( void )
	{
		delete [] m_pLeftValue;
		delete [] m_pConstLeftValue;
	}

	virtual CUkkonen *clone( void )
	{
		return new CUkkonenGraph( *this );
	}


	virtual void SetData( double *input, long nDatSize, bool ParChanged );

	virtual void GetGraph( long *SizeArray, double *&cons, long *&left, long *&oper, long *&right, long *&output )
	{
		m_TheGraph.GetGraph( SizeArray, cons, left, oper, right, output, 1 );
	}

	virtual long GetMemAlloc( void )
	{
		return CUkkonen::GetMemAlloc() + m_TheGraph.GetMemAlloc() +
			( m_nNodeSize + m_nConSize ) * sizeof( long );
	}

	virtual long GetMemUsed( void )
	{
		long nop;
		long nvary;
		long nfind;
		long nfix;
		m_TheGraph.GetSizes( nop, nvary, nfind, nfix );
		return CUkkonen::GetMemUsed() + m_TheGraph.GetMemUsed() +
			( nop + nvary + nfix ) * sizeof( long );
	}




};

#endif

